/**
 * \file		msg.h
 * \author 		Tranchida Giulio, No Matricola 241732\n
 * \brief  		Strutture dati e definizioni per lo scambio messaggi\n\n
 *
 *
 * This program is free software; you can redistribuite it and/or modify
 * it under the terms of the GNU/General Pubblic License as published the
 * Free software Foundation; either version 2 of the License, or
 * (at your opinion) any later version.
 * */

/** <h3>Messaggio</h3>
 * La struttura \c message_t rappresenta un messaggio tra client e server
 * - \c type rappresenta il tipo del messaggio
 * - \c length rappresenta la lunghezza in byte del campo buffer
 * - \c buffer e' il puntatore al messaggio
 *
 * <hr>
 */
#ifndef MSG_H
#define MSG_H

typedef struct {
    char type;           /**< tipo del messaggio */
    unsigned int length; /**< lunghezza in byte */
    char* buffer;        /**< buffer messaggio */
} message_t; 

/** fine dello stream, connessione chiusa dal peer */
#define SEOF -2

/** tipo dei messaggi di errore */
#define MSG_ERROR        'E' 
/** tipo dei messaggi di OK */
#define MSG_OK           'O'
/** messaggio di test */
#define MSG_PRINT		 'P'
/** messaggio di test */
#define MSG_EXIT         'X'

#endif
