/**
 * 	\file		 clientSSL.c
 *	\author		 Tranchida Giulio, No Matricola 241732\n
 *				 Si dichiara che il contenuto di questo file e',
 * 				 in ogni sua parte, opera originale dell'autore.\n\n
 *
 * This program is free software; you can redistribuite it and/or modify
 * it under the terms of the GNU/General Pubblic License as published the
 * Free software Foundation; either version 2 of the License, or
 * (at your opinion) any later version.
 * */

#include <stdlib.h>
#include <string.h>

#include "errore.h"
#include "commSSL.h"

/** client di esempio */
int main(int argc,char* argv[]){
	message_t msg;
	char * hostname;	/**< Nome del server */
	char * service;		/**< Nome del servizio o numero di porta */
	int sent;
	cli_conn * client;	/**< Struttura di comunicazione con il server */

	char messaggio[32768];

	hostname = "localhost";
	service = "12100";

	/* Apro la socket di comunicazione col server */
	if ((client = retrySSLConnection(hostname, service)) == NULL) {
		sys_err(__FILE__,__LINE__,"Client: Errore nella apertura del socket di comunicazione");
		exit(EXIT_FAILURE);
	}

	/* Preparo il messaggio da inviare al server
	 * Abbastanza grande da forzare due read nella commSSL.c
	 *  */
	msg.type = MSG_PRINT;
	msg.length = 32768;
	memset(&messaggio, 65, 32768);
	msg.buffer = messaggio;

	/* invio un messaggio */
	if ((sent = sendSSLMessage(client, &msg)) == -1){
		if (client->socket != -1) closeSSLConnection(client);
		exit(EXIT_FAILURE);
	}

	/* ricevo la risposta */
	if (receiveSSLMessage(client, &msg) == -1){
		if (client->socket != -1) closeSSLConnection(client);
		exit(EXIT_FAILURE);
	}

	if (msg.type==MSG_OK)
		printf("Client: conferma ricezione messaggio\n");
	else{
		fprintf(stderr,"Client: messaggio non riconosciuto\n");
		closeSSLConnection(client);
		exit(EXIT_FAILURE);
	}

	/* Chiudo la socket di comunicazione del client */
	closeSSLConnection(client);
	unloadSSL();
	return 0;
}
