/**
 * 	\file		errore.c
 *	\author		Tranchida Giulio, No Matricola 241732\n
 *				Si dichiara che il contenuto di questo file e',
 * 				in ogni sua parte, opera originale dell'autore.\n\n
 *
 * This program is free software; you can redistribuite it and/or modify
 * it under the terms of the GNU/General Pubblic License as published the
 * Free software Foundation; either version 2 of the License, or
 * (at your opinion) any later version.
 * */
#include "errore.h"

#ifdef _DEBUG_MODE

int sys_err(const char *file, int line, const char *format, ...){
	va_list arg;
	
	fprintf(stderr,"Errore file %s, linea %d. Error No:%d\n", file, line-1, errno);
	va_start (arg, format);
	vfprintf(stderr, format, arg);
	va_end (arg);
	perror(0);
	return errno;
}

void gen_err(const char *file, int line, const char *format, ...){
	va_list arg;
	
	fprintf(stderr,"Errore file %s, linea %d\n", file, line-1);
	va_start (arg, format);
	vfprintf(stderr, format, arg);
	va_end (arg);
	return;
}

#else

int sys_err(const char *file, int line, const char *format, ...){
	return errno;
}

void gen_err(const char *file, int line, const char *format, ...){
	return;
}

#endif

